package com.madeu.controller.mobile.mobilemedical;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobilelogin.MobileLoginService;
import com.madeu.service.mobile.mobilemedical.MobileMedicalService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller
public class MobileMedicalController extends ManagerDraftAction {

	@Autowired
	private MobileMedicalService mobileMedicalService;

	/**
	 * 시술 상세 화면 이동
	 * 페이지 처리 없음
	 * request:
	 * response : msgCode, msgDesc
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value = "/mobilemedical/selectMedicalIntro.do")
	public String selectMedicalIntro(HttpSession session, HttpServletRequest request, Model model) {
		log.debug("MobileEventController  selectMedicalIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try {
			if (!mobileCheckLogin(session)) {
				return "/mobile/login/login";
			} else {
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
			}
		} catch (Exception e) {
			e.printStackTrace();
			return "/mobile/login/login";
		}
		log.debug("MobileEventController  selectMedicalIntro END");
		return "/mobile/medical/selectMedical";
	}
	/**
	 * 시술보드 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value = "/mobilemedical/selectListMedicalBoard.do")
	public ModelAndView selectListCompany(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileMedicalController selectListMedicalBoard START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMedicalService.selectListMedicalBoard(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileHomeController selectListMedicalBoard END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 시술 정보 리스트 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value = "/mobilemedical/selectListMedical.do")
	public ModelAndView selectListMedical(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileHomeController selectListMedical START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMedicalService.selectListMedical(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileHomeController selectListMedical END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}

	/**
	 * 시술 정보 조회
	 *
	 * @param request
	 * @param response
	 * @return
	 */
	@RequestMapping(value = "/mobilemedical/selectMedical.do")
	public ModelAndView selectMedical(HttpSession session, HttpServletRequest request, HttpServletResponse response) {

		log.debug("MobileHomeController selectMedical START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();

		try{
			if(!mobileCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginUserId", String.valueOf(session.getAttribute("loginUserId")));
				map = mobileMedicalService.selectMedical(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("MobileHomeController selectMedical END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
}